﻿Imports System.Runtime.InteropServices

Public Class Form1
    Public sImageFile As String
    Private Declare Function DeleteObject Lib "gdi32" Alias "DeleteObject" (ByVal hObject As Long) As Long

    Private Sub btnRecogFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRecogFile.Click
        Dim sFileName As String
        Dim pResult As IntPtr
        Dim nSize As Integer

        If dlgOpen.ShowDialog() = DialogResult.OK Then
            sFileName = dlgOpen.FileName
            picView.Load(sFileName)
            nSize = 0
            pResult = PDF417DecodeHead.PDF417DecodeImageFile(sFileName)

            If pResult <> 0 Then
                AnalyticalData(pResult)
                PDF417DecodeHead.PDF417Free(pResult)
            Else
                tbInfo.Clear()
                tbInfo.Text = "no barcode found"
            End If
            btnRecognize.Enabled = False
        End If
    End Sub

    Private Sub btnOpenFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpenFile.Click
        If dlgOpen.ShowDialog() = DialogResult.OK Then
            tbInfo.Clear()
            sImageFile = dlgOpen.FileName
            picView.Load(sImageFile)
            btnRecognize.Enabled = True
        End If

    End Sub

    Private Sub btnRecognize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRecognize.Click
        Dim hBitmap As Integer
        Dim pResult As IntPtr
        Dim lReult As Integer

        hBitmap = PDF417DecodeHead.LoadImageEx(sImageFile)
        If hBitmap <> 0 Then
            pResult = PDF417DecodeHead.PDF417DecodeBitmap(hBitmap)
            lReult = DeleteObject(hBitmap)
            hBitmap = 0
            If pResult <> 0 Then
                AnalyticalData(pResult)
                PDF417DecodeHead.PDF417Free(pResult)
            Else
                tbInfo.Clear()
                tbInfo.Text = "no barcode found"
            End If
        End If
    End Sub

    Public Sub AnalyticalData(ByVal pResult As IntPtr)
        Dim sTemp As String
        Dim sAscll As String
        Dim sHex As String
        Dim sbyteHex As String
        Dim r As Result
        Dim bBuf(0 To 8192) As Byte
        Dim nCount As Integer
        Dim sSpace As String

        nCount = 1
        r = Marshal.PtrToStructure(pResult, r.GetType())
        Marshal.Copy(r.pData, bBuf, 0, r.nSize)

        sTemp = "barcode detected" & vbCrLf & "Position:   "
        For i = 0 To 3
            sTemp = sTemp & "(" & Str(r.ptCorner(i).X) & "," & Str(r.ptCorner(i).Y) & ")  "
        Next
        sTemp = sTemp & vbCrLf

        For i = 0 To r.nSize
            sbyteHex = Hex(bBuf(i))
            If (Len(sbyteHex) < 2) And (Len(sbyteHex) > 0) Then
                sbyteHex = "0" & sbyteHex
            End If
            sHex = sHex + sbyteHex + " "
            If (bBuf(i) >= 32) And (bBuf(i) < 127) Then
                sAscll = sAscll + Chr(bBuf(i))
            Else
                sAscll = sAscll + "."
            End If
            nCount = nCount + 1
            If nCount Mod 17 = 0 Then
                sTemp = sTemp & sHex & "        " & sAscll & vbCrLf
                nCount = 1
                sHex = ""
                sAscll = ""
            End If

        Next

        If nCount <> 1 Then
            For i = 0 To (16 - nCount)
                sSpace = sSpace & "  "
            Next
            sTemp = sTemp & sHex & sSpace & "        " & sAscll & vbCrLf
        End If

        tbInfo.Clear()
        tbInfo.Text = sTemp
    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Process.GetCurrentProcess.CloseMainWindow()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim sWarning As String

        sWarning = "* Trial version will replace first char of the result with '*' randomly" & vbCrLf & "* Please select or open file to decode"
        tbInfo.Clear()
        tbInfo.Text = sWarning

    End Sub
End Class
